<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesCourseProxy extends \Entities\Course implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function code($code = NULL)
    {
        $this->__load();
        return parent::code($code);
    }

    public function name($name = NULL)
    {
        $this->__load();
        return parent::name($name);
    }

    public function lang($lang = NULL)
    {
        $this->__load();
        return parent::lang($lang);
    }

    public function type($type = NULL)
    {
        $this->__load();
        return parent::type($type);
    }

    public function addPart(\Entities\Part $part)
    {
        $this->__load();
        return parent::addPart($part);
    }

    public function parts()
    {
        $this->__load();
        return parent::parts();
    }

    public function addLesson(\Entities\Lesson $lesson)
    {
        $this->__load();
        return parent::addLesson($lesson);
    }

    public function lessons()
    {
        $this->__load();
        return parent::lessons();
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'code', 'name', 'lang', 'type', 'parts', 'lessons');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}